-----------------------------------------------------
-- Tidy Plates: Neon/Tank - Theme Definition
-----------------------------------------------------
TidyPlatesThemeList["Neon/Tank"] = {}
local Theme = TidyPlatesThemeList["Neon/Tank"]

---------------
-- Config
---------------
TidyPlatesNeonTankVariables = {
	OpacityNonTarget = .5,
	OpacityHideNeutral = false,
	OpacityHideNonElites = false,
	ScaleGeneral = 1,
	ScaleLoose = 1.2,
	ScaleIgnoreNonElite = false,
	WidgetTug = true,
	WidgetSelect = true,
	WidgetDebuff = false,
	WidgetDebuffList = { ["Rip"] = true, ["Rake"] = true, ["Lacerate"] = true, },
	WidgetDebuffMode = 1,
	WidgetRange	= false,
	WidgetCombo = false,
	WidgetWheel = false,
	WidgetClassIcon = false,
	RangeMode = 1,
	HealthText = 1,
	LevelText = false,
	AggroHealth = true, 
	AggroBorder = false,
	AggroLooseColor = {r = 15/255, g = 133/255, b = 255/255},	
	AggroTankedColor = {r = 255/255, g = 128/255, b = 0,},	
	AggroOtherColor = {r = 255/255, g = 128/255, b = 0,},	
	TugWidgetLooseColor = { r = .14, g = .75, b = 1},
	TugWidgetAggroColor = {r = 1, g = .67, b = .14},
	TugWidgetSafeColor = { r = 0, g = .9, b = .1},
	--CustomFont = 1,
	--CustomFontSize = 11,
}

---------------------------------------------
-- Style Definition
---------------------------------------------
local ArtworkPath = "Interface\\Addons\\TidyPlates_Neon\\Media\\"
local EmptyTexture = ArtworkPath.."Neon_Empty"
local CastBarVerticalAdjustment = -21
local NameTextVerticalAdjustment = -8

---------------------------------------------
-- Default Style
---------------------------------------------
local DefaultStyle = Theme
DefaultStyle.hitbox = {
	width = 105,
	height = 20,
}

DefaultStyle.frame = {
	x = 0,
	y = 4,
}

DefaultStyle.healthborder = {
	texture		 =				ArtworkPath.."Neon_HealthOverlay",
	glowtexture =					ArtworkPath.."Neon_Highlight",
	elitetexture =					ArtworkPath.."Neon_HealthOverlayEliteStar",
	width = 128,
	height = 32,
	y = 0,
}

DefaultStyle.healthbar = {
	texture =					 ArtworkPath.."Neon_Bar",
	width = 100,
	height = 32,
	x = 0,
	y = 0,
}

DefaultStyle.castborder = {
	texture =					ArtworkPath.."Neon_CastOverlayBlue",
	width = 128,
	height = 32,
	x = 0,
	y = CastBarVerticalAdjustment,
}

DefaultStyle.castnostop = {
	texture =					ArtworkPath.."Neon_CastOverlayRed",
	width = 128,
	height = 32,
	x = 0,
	y = CastBarVerticalAdjustment,
}


DefaultStyle.castbar = {
	texture =					 ArtworkPath.."Neon_Bar",
	width = 100,
	height = 32,
	x = 0,
	y = CastBarVerticalAdjustment,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
}

DefaultStyle.threatborder = {
	texture =				ArtworkPath.."Neon_AggroOverlayWhite",
	--elitetexture =				ArtworkPath.."Neon_Empty",
	elitetexture =			ArtworkPath.."Neon_AggroOverlayWhite",
	width = 256,
	height = 64,
	y = 1,
}

DefaultStyle.spellicon = {
	width = 17,
	height = 17,
	x = 26,
	y = -3+CastBarVerticalAdjustment,
	anchor = "CENTER",
}

DefaultStyle.raidicon = {
	width = 32,
	height = 32,
	x = -48,
	y = 3,
	anchor = "CENTER",
}

DefaultStyle.name = {
	typeface = ArtworkPath.."Qlassik_TB.ttf",
	size = 13,
	width = 200,
	height = 11,
	x = 0,
	y = NameTextVerticalAdjustment,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = true,
	
	
	--typeface = "FONTS/ARIALN.TTF",
	--size = 12,
}

DefaultStyle.level = {
	typeface = ArtworkPath.."Qlassik_TB.ttf",
	size = 9,
	width = 22,
	height = 11,
	x = 5,
	y = 5,
	align = "LEFT",
	anchor = "LEFT",
	vertical = "CENTER",
	flags = "OUTLINE",
	shadow = false,
}

DefaultStyle.dangerskull = {
	width = 14,
	height = 14,
	x = 5,
	y = 5,
	anchor = "LEFT",
}

DefaultStyle.specialText = {
	typeface = ArtworkPath.."Qlassik_TB.ttf",
	size = 11,
	width = 150,
	height = 11,
	x = 26,
	y = -19+CastBarVerticalAdjustment,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = true,
}

DefaultStyle.specialText2 = {
	typeface = ArtworkPath.."Qlassik_TB.ttf",
	size = 9,
	width = 150,
	height = 11,
	x = 0,
	y = 1,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = false,
	flags = "OUTLINE",
}

DefaultStyle.options = {
	showName = true,
	showLevel = false,
	showDangerSkull = true,
	showSpecialText = true,
	showSpecialText2 = true,
	showSpecialArt = true,
	useCustomHealthbarColor = true,
}

--[[
local CopyTable = TidyPlatesUtility.copyTable

---------------------------------------------
-- Style
---------------------------------------------
local NoNameStyle = CopyTable(DefaultStyle)
NoNameStyle.options.showName = false
NoNameStyle.options.showLevel = false
NoNameStyle.options.showDangerSkull = false
NoNameStyle.options.showSpecialText = false
NoNameStyle.options.showSpecialText2 = false

---------------------------------------------
-- Style
---------------------------------------------
local NoHealthBarStyle = CopyTable(DefaultStyle)
NoHealthBarStyle.healthborder.texture = EmptyTexture
NoHealthBarStyle.healthborder.glowtexture = EmptyTexture
NoHealthBarStyle.healthborder.elitetexture = EmptyTexture
NoHealthBarStyle.healthbar.texture = EmptyTexture
NoHealthBarStyle.name.size = 14
NoHealthBarStyle.name.y = NameTextVerticalAdjustment + 8
NoHealthBarStyle.options.showLevel = false
NoHealthBarStyle.options.showDangerSkull = false
NoHealthBarStyle.options.showSpecialText = false
NoHealthBarStyle.options.showSpecialText2 = false

local function StyleDelegate(unit)
	-- DefaultStyle, NoNameStyle, or NoHealthBarStyle
	if unit.reaction == "HOSTILE" then return "DefaultStyle"
	else return "NoNameStyle" end
end

Theme.SetStyle = StyleDelegate

--]]

local function UpdateStyleElements(self, var)
	Theme.options.showLevel = (TidyPlatesNeonTankVariables.LevelText == true)
end

Theme.UpdateStyleElements = UpdateStyleElements




